#
# Author: Kapil Thangavelu <kvthan@wm.edu>
# CVS: $Id: Builder.py,v 1.4 2001/09/28 00:25:17 ender Exp $
# License: GPL
 
import re, string

#from interfaces.IBuilder import IBuilder
from ZoacsQuery import ZoacsQuery

class Builder:

    #__implements__ = IBuilder

    def build(self, conn_id, id, query_dict):
        pass

class QueryBuilder(Builder):
        
    def build(self, conn_id, id, query_dict):

        assert conn_id is not None
        assert query_dict.has_key('name')
        assert query_dict.has_key('source')

        return ZoacsQuery(id,
                   query_dict['name'],
                   conn_id,
                   '',
                   query_dict['source']
                   )
        

re_bind_args = re.compile(':([A-z]+)')

class BindQueryBuilder(Builder):
    """ converts bind vars to sqlvars, 
    only for use with pg which does this
    type of thing behind the scenes
    since spi doesn't support bind vars 
    that i know of in 7.1"""
        
    def build(self, conn_id, id, query_dict):
        """
        find all bind args
        replace bind args with what?? sqlvar
        requires attribute test...
        need to investigate bind syntax
        for now just dtml-var it.

        next look for dynamic sql and
        use the var name as arg again
        with a dtml-var
        
        this seems more than a little broken
        """
        #print 'builder'
        assert conn_id is not None
        assert query_dict.has_key('name')
        assert query_dict.has_key('source')
        
        query = query_dict['source']
        
        bind_args = re_bind_args.findall(query)
        for b in bind_args:
            query=string.replace(query, ':'+b,'<dtml-var %s>'%b)

        """
        dynamic_args = re_dyn_args.findall(query)
        for d in dynamic_args:
            query=string.replace(query, '$'+d,'<dtml-var %s>'%d)
        """
            
        args = bind_args #+ dynamic_args
        args = string.join(args, '\n')
        
        return ZoacsQuery(id, query_dict['name'], conn_id, args, query)
        
